diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/bindings/modulegen__gcc_LP64.py ns-3.31/src/internet/bindings/modulegen__gcc_LP64.py
--- ns-3.30.1/src/internet/bindings/modulegen__gcc_LP64.py	2019-08-12 17:00:27.000000000 -0700
+++ ns-3.31/src/internet/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
@@ -20596,32 +21075,32 @@
     cls.add_method('IsBridge', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## loopback-net-device.h (module 'internet'): bool ns3::LoopbackNetDevice::IsBroadcast() const [member function]
     cls.add_method('IsBroadcast', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## loopback-net-device.h (module 'internet'): bool ns3::LoopbackNetDevice::IsLinkUp() const [member function]
     cls.add_method('IsLinkUp', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## loopback-net-device.h (module 'internet'): bool ns3::LoopbackNetDevice::IsMulticast() const [member function]
     cls.add_method('IsMulticast', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## loopback-net-device.h (module 'internet'): bool ns3::LoopbackNetDevice::IsPointToPoint() const [member function]
     cls.add_method('IsPointToPoint', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## loopback-net-device.h (module 'internet'): bool ns3::LoopbackNetDevice::NeedsArp() const [member function]
     cls.add_method('NeedsArp', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## loopback-net-device.h (module 'internet'): bool ns3::LoopbackNetDevice::Send(ns3::Ptr<ns3::Packet> packet, ns3::Address const & dest, uint16_t protocolNumber) [member function]
     cls.add_method('Send', 
                    'bool', 
@@ -20666,7 +21145,7 @@
     cls.add_method('SupportsSendFrom', 
                    'bool', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## loopback-net-device.h (module 'internet'): void ns3::LoopbackNetDevice::DoDispose() [member function]
     cls.add_method('DoDispose', 
                    'void', 
@@ -20709,22 +21188,22 @@
     cls.add_method('AddHeader', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## queue-item.h (module 'network'): void ns3::QueueDiscItem::Print(std::ostream & os) const [member function]
     cls.add_method('Print', 
                    'void', 
                    [param('std::ostream &', 'os')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## queue-item.h (module 'network'): bool ns3::QueueDiscItem::Mark() [member function]
     cls.add_method('Mark', 
                    'bool', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## queue-item.h (module 'network'): uint32_t ns3::QueueDiscItem::Hash(uint32_t perturbation=0) const [member function]
     cls.add_method('Hash', 
                    'uint32_t', 
                    [param('uint32_t', 'perturbation', default_value='0')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     return
 
 def register_Ns3ArpQueueDiscItem_methods(root_module, cls):
@@ -20734,7 +21213,7 @@
     cls.add_method('GetSize', 
                    'uint32_t', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## arp-queue-disc-item.h (module 'internet'): ns3::ArpHeader const & ns3::ArpQueueDiscItem::GetHeader() const [member function]
     cls.add_method('GetHeader', 
                    'ns3::ArpHeader const &', 
@@ -20749,7 +21228,7 @@
     cls.add_method('Print', 
                    'void', 
                    [param('std::ostream &', 'os')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## arp-queue-disc-item.h (module 'internet'): bool ns3::ArpQueueDiscItem::Mark() [member function]
     cls.add_method('Mark', 
                    'bool', 
@@ -20759,7 +21238,7 @@
     cls.add_method('Hash', 
                    'uint32_t', 
                    [param('uint32_t', 'perturbation')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     return
 
 def register_Ns3Ipv4QueueDiscItem_methods(root_module, cls):
@@ -20769,7 +21248,7 @@
     cls.add_method('GetSize', 
                    'uint32_t', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## ipv4-queue-disc-item.h (module 'internet'): ns3::Ipv4Header const & ns3::Ipv4QueueDiscItem::GetHeader() const [member function]
     cls.add_method('GetHeader', 
                    'ns3::Ipv4Header const &', 
@@ -20784,12 +21263,12 @@
     cls.add_method('Print', 
                    'void', 
                    [param('std::ostream &', 'os')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## ipv4-queue-disc-item.h (module 'internet'): bool ns3::Ipv4QueueDiscItem::GetUint8Value(ns3::QueueItem::Uint8Values field, uint8_t & value) const [member function]
     cls.add_method('GetUint8Value', 
                    'bool', 
                    [param('ns3::QueueItem::Uint8Values', 'field'), param('uint8_t &', 'value')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## ipv4-queue-disc-item.h (module 'internet'): bool ns3::Ipv4QueueDiscItem::Mark() [member function]
     cls.add_method('Mark', 
                    'bool', 
@@ -20799,7 +21278,7 @@
     cls.add_method('Hash', 
                    'uint32_t', 
                    [param('uint32_t', 'perturbation')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     return
 
 def register_Ns3Ipv6QueueDiscItem_methods(root_module, cls):
@@ -20809,7 +21288,7 @@
     cls.add_method('GetSize', 
                    'uint32_t', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## ipv6-queue-disc-item.h (module 'internet'): ns3::Ipv6Header const & ns3::Ipv6QueueDiscItem::GetHeader() const [member function]
     cls.add_method('GetHeader', 
                    'ns3::Ipv6Header const &', 
@@ -20824,12 +21303,12 @@
     cls.add_method('Print', 
                    'void', 
                    [param('std::ostream &', 'os')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## ipv6-queue-disc-item.h (module 'internet'): bool ns3::Ipv6QueueDiscItem::GetUint8Value(ns3::QueueItem::Uint8Values field, uint8_t & value) const [member function]
     cls.add_method('GetUint8Value', 
                    'bool', 
                    [param('ns3::QueueItem::Uint8Values', 'field'), param('uint8_t &', 'value')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## ipv6-queue-disc-item.h (module 'internet'): bool ns3::Ipv6QueueDiscItem::Mark() [member function]
     cls.add_method('Mark', 
                    'bool', 
@@ -20839,7 +21318,7 @@
     cls.add_method('Hash', 
                    'uint32_t', 
                    [param('uint32_t', 'perturbation')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
@@ -20851,7 +21330,7 @@
     cls.add_method('GetHash32', 
                    'uint32_t', 
                    [param('char const *', 'buffer'), param('std::size_t const', 'size')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## hash-function.h (module 'core'): uint64_t ns3::Hash::Implementation::GetHash64(char const * buffer, std::size_t const size) [member function]
     cls.add_method('GetHash64', 
                    'uint64_t', 
@@ -20861,7 +21340,7 @@
     cls.add_method('clear', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashFunctionFnv1a_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/examples/main-simple.cc ns-3.31/src/internet/examples/main-simple.cc
--- ns-3.30.1/src/internet/examples/main-simple.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/examples/main-simple.cc	2020-06-27 17:38:30.000000000 -0700
@@ -87,7 +87,7 @@
 
 int main (int argc, char *argv[])
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
   
   RunSimulation ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/helper/ipv6-address-helper.cc ns-3.31/src/internet/helper/ipv6-address-helper.cc
--- ns-3.30.1/src/internet/helper/ipv6-address-helper.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/helper/ipv6-address-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -231,6 +231,9 @@
       NS_ASSERT_MSG (ifIndex >= 0, "Ipv6AddressHelper::Allocate (): "
                      "Interface index not found");
 
+      // the first round is to make sure that the interface is set up, including its link-local addresses.
+      ipv6->SetUp (ifIndex);
+
       Ipv6InterfaceAddress ipv6Addr = Ipv6InterfaceAddress (NewAddress (device->GetAddress ()), Ipv6Prefix (64));
       ipv6->SetMetric (ifIndex, 1);
       ipv6->AddAddress (ifIndex, ipv6Addr);
@@ -284,6 +287,9 @@
       NS_ASSERT_MSG (ifIndex >= 0, "Ipv6AddressHelper::Allocate (): "
                      "Interface index not found");
 
+      // the first round is to make sure that the interface is set up, including its link-local addresses.
+      ipv6->SetUp (ifIndex);
+
       ipv6->SetMetric (ifIndex, 1);
 
       if (withConfiguration.at (i))
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/arp-cache.cc ns-3.31/src/internet/model/arp-cache.cc
--- ns-3.30.1/src/internet/model/arp-cache.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/arp-cache.cc	2020-06-27 17:38:30.000000000 -0700
@@ -105,7 +105,7 @@
   m_interface = 0;
   if (!m_waitReplyTimer.IsRunning ())
     {
-      Simulator::Remove (m_waitReplyTimer);
+      m_waitReplyTimer.Cancel ();
     }
   Object::DoDispose ();
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/arp-l3-protocol.cc ns-3.31/src/internet/model/arp-l3-protocol.cc
--- ns-3.30.1/src/internet/model/arp-l3-protocol.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/arp-l3-protocol.cc	2020-06-27 17:38:30.000000000 -0700
@@ -228,7 +228,7 @@
           break;
         } 
       else if (arp.IsReply () && 
-               arp.GetDestinationIpv4Address ().IsEqual (cache->GetInterface ()->GetAddress (i).GetLocal ()) &&
+               arp.GetDestinationIpv4Address () == cache->GetInterface ()->GetAddress (i).GetLocal () &&
                arp.GetDestinationHardwareAddress () == device->GetAddress ())
         {
           found = true;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/global-route-manager-impl.cc ns-3.31/src/internet/model/global-route-manager-impl.cc
--- ns-3.30.1/src/internet/model/global-route-manager-impl.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/global-route-manager-impl.cc	2020-06-27 17:38:30.000000000 -0700
@@ -34,7 +34,6 @@
 #include "ns3/ipv4.h"
 #include "ns3/ipv4-routing-protocol.h"
 #include "ns3/ipv4-list-routing.h"
-#include "ns3/mpi-interface.h"
 #include "global-router-interface.h"
 #include "global-route-manager-impl.h"
 #include "candidate-queue.h"
@@ -711,7 +710,7 @@
       Ptr<GlobalRouter> rtr = 
         node->GetObject<GlobalRouter> ();
 
-      uint32_t systemId = MpiInterface::GetSystemId ();
+      uint32_t systemId = Simulator::GetSystemId ();
       // Ignore nodes that are not assigned to our systemId (distributed sim)
       if (node->GetSystemId () != systemId) 
         {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/icmpv6-header.cc ns-3.31/src/internet/model/icmpv6-header.cc
--- ns-3.30.1/src/internet/model/icmpv6-header.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/icmpv6-header.cc	2020-06-27 17:38:30.000000000 -0700
@@ -758,7 +758,7 @@
 void Icmpv6RS::Serialize (Buffer::Iterator start) const
 {
   NS_LOG_FUNCTION (this << &start);
-  NS_LOG_FUNCTION_NOARGS ();
+
   uint16_t checksum = 0;
   Buffer::Iterator i = start;
 
@@ -1494,7 +1494,7 @@
 
 uint8_t Icmpv6OptionHeader::GetType () const
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   return m_type;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/icmpv6-l4-protocol.cc ns-3.31/src/internet/model/icmpv6-l4-protocol.cc
--- ns-3.30.1/src/internet/model/icmpv6-l4-protocol.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/icmpv6-l4-protocol.cc	2020-06-27 17:38:30.000000000 -0700
@@ -32,7 +32,6 @@
 #include "ns3/string.h"
 #include "ns3/integer.h"
 
-#include "ipv6-raw-socket-factory-impl.h"
 #include "ipv6-l3-protocol.h"
 #include "ipv6-interface.h"
 #include "icmpv6-l4-protocol.h"
@@ -99,6 +98,12 @@
   return tid;
 }
 
+TypeId Icmpv6L4Protocol::GetInstanceTypeId () const
+{
+  NS_LOG_FUNCTION (this);
+  return Icmpv6L4Protocol::GetTypeId ();
+}
+
 Icmpv6L4Protocol::Icmpv6L4Protocol ()
   : m_node (0)
 {
@@ -146,8 +151,6 @@
             {
               SetNode (node);
               ipv6->Insert (this);
-              Ptr<Ipv6RawSocketFactoryImpl> rawFactory = CreateObject<Ipv6RawSocketFactoryImpl> ();
-              ipv6->AggregateObject (rawFactory);
               SetDownTarget6 (MakeCallback (&Ipv6::Send, ipv6));
             }
         }
@@ -161,6 +164,12 @@
   m_node = node;
 }
 
+Ptr<Node> Icmpv6L4Protocol::GetNode ()
+{
+  NS_LOG_FUNCTION (this);
+  return m_node;
+}
+
 uint16_t Icmpv6L4Protocol::GetStaticProtocolNumber ()
 {
   NS_LOG_FUNCTION_NOARGS ();
@@ -199,7 +208,7 @@
     }
 
   /** \todo disable multicast loopback to prevent NS probing to be received by the sender */
-
+  
   NdiscCache::Ipv6PayloadHeaderPair p = ForgeNS ("::",Ipv6Address::MakeSolicitedAddress (target), target, interface->GetDevice ()->GetAddress ());
 
   /* update last packet UID */
@@ -563,7 +572,10 @@
     }
 
   hardwareAddress = interface->GetDevice ()->GetAddress ();
-  NdiscCache::Ipv6PayloadHeaderPair p = ForgeNA (target.IsLinkLocal () ? interface->GetLinkLocalAddress ().GetAddress () : ifaddr.GetAddress (), src.IsAny () ? Ipv6Address::GetAllNodesMulticast () : src, &hardwareAddress, flags );
+  NdiscCache::Ipv6PayloadHeaderPair p = ForgeNA (target.IsLinkLocal () ? interface->GetLinkLocalAddress ().GetAddress () : ifaddr.GetAddress (),
+                                                 src.IsAny () ? dst : src, // DAD replies must go to the multicast group it was sent to.
+                                                 &hardwareAddress,
+                                                 flags );
   interface->Send (p.first, p.second, src.IsAny () ? Ipv6Address::GetAllNodesMulticast () : src);
 
   /* not a NS for us discard it */
@@ -789,7 +801,7 @@
         {
           entry = cache->Add (redirTarget);
           /* destination and target different => necessarily a router */
-          entry->SetRouter (!redirTarget.IsEqual (redirDestination) ? true : false);
+          entry->SetRouter (redirTarget != redirDestination);
           entry->SetMacAddress (llOptionHeader.GetAddress ());
           entry->MarkStale ();
         }
@@ -814,7 +826,7 @@
   /* add redirection in routing table */
   Ptr<Ipv6> ipv6 = m_node->GetObject<Ipv6> ();
 
-  if (redirTarget.IsEqual (redirDestination))
+  if (redirTarget == redirDestination)
     {
       ipv6->GetRoutingProtocol ()->NotifyAddRoute (redirDestination, Ipv6Prefix (128), Ipv6Address ("::"), ipv6->GetInterfaceForAddress (dst));
     }
@@ -1244,12 +1256,6 @@
   Icmpv6NS ns (target);
   Icmpv6OptionLinkLayerAddress llOption (1, hardwareAddress);  /* we give our mac address in response */
 
-  /* if the source is unspec, multicast the NA to all-nodes multicast */
-  if (src == Ipv6Address::GetAny ())
-    {
-      dst = Ipv6Address::GetAllNodesMulticast ();
-    }
-
   NS_LOG_LOGIC ("Send NS ( from " << src << " to " << dst << " target " << target << ")");
 
   p->AddHeader (llOption);
@@ -1277,7 +1283,7 @@
         }
     }
 
-  NS_ASSERT (false);
+  NS_ASSERT_MSG (false, "Icmpv6L4Protocol can not find a NDIS Cache for device " << device);
   /* quiet compiler */
   return 0;
 }
@@ -1400,10 +1406,10 @@
   return false;
 }
 
-void Icmpv6L4Protocol::FunctionDadTimeout (Ptr<Icmpv6L4Protocol> icmpv6, Ipv6Interface* interface, Ipv6Address addr)
+void Icmpv6L4Protocol::FunctionDadTimeout (Ipv6Interface* interface, Ipv6Address addr)
 {
-  NS_LOG_FUNCTION_NOARGS ();
-  NS_LOG_LOGIC (interface << " " << addr);
+  NS_LOG_FUNCTION  (this << interface << addr);
+
   Ipv6InterfaceAddress ifaddr;
   bool found = false;
   uint32_t i = 0;
@@ -1420,6 +1426,11 @@
         }
     }
 
+  if (!found)
+    {
+      NS_LOG_LOGIC ("Can not find the address in the interface.");
+    }
+
   /* for the moment, this function is always called, if we was victim of a DAD the address is INVALID
    * and we do not set it to PREFERRED
    */
@@ -1431,14 +1442,19 @@
       /* send an RS if our interface is not forwarding (router) and if address is a link-local ones
        * (because we will send RS with it)
        */
-      Ptr<Ipv6> ipv6 = icmpv6->m_node->GetObject<Ipv6> ();
+      Ptr<Ipv6> ipv6 = m_node->GetObject<Ipv6> ();
 
       if (!ipv6->IsForwarding (ipv6->GetInterfaceForDevice (interface->GetDevice ())) && addr.IsLinkLocal ())
         {
           /* \todo Add random delays before sending RS
            * because all nodes start at the same time, there will be many of RS around 1 second of simulation time
            */
-          Simulator::Schedule (Seconds (0.0), &Icmpv6L4Protocol::SendRS, PeekPointer (icmpv6), ifaddr.GetAddress (), Ipv6Address::GetAllRoutersMulticast (), interface->GetDevice ()->GetAddress ());
+          NS_LOG_LOGIC ("Scheduled a Router Solicitation");
+          Simulator::Schedule (Seconds (0.0), &Icmpv6L4Protocol::SendRS, this, ifaddr.GetAddress (), Ipv6Address::GetAllRoutersMulticast (), interface->GetDevice ()->GetAddress ());
+        }
+      else
+        {
+          NS_LOG_LOGIC ("Did not schedule a Router Solicitation because the interface is in forwarding mode");
         }
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/icmpv6-l4-protocol.h ns-3.31/src/internet/model/icmpv6-l4-protocol.h
--- ns-3.30.1/src/internet/model/icmpv6-l4-protocol.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/icmpv6-l4-protocol.h	2020-06-27 17:38:30.000000000 -0700
@@ -57,6 +57,7 @@
    * \return the object TypeId
    */
   static TypeId GetTypeId ();
+  virtual TypeId GetInstanceTypeId (void) const;
 
   /**
    * \brief ICMPv6 protocol number (58).
@@ -116,6 +117,12 @@
   void SetNode (Ptr<Node> node);
 
   /**
+   * \brief Get the node.
+   * \return node
+   */
+  Ptr<Node> GetNode ();
+
+  /**
    * \brief This method is called by AggregateObject and completes the aggregation
    * by setting the node in the ICMPv6 stack and adding ICMPv6 factory to
    * IPv6 stack connected to the node.
@@ -199,7 +206,7 @@
    * \param target target IPv6 address
    * \param hardwareAddress our mac address
    */
-  void SendNS (Ipv6Address src, Ipv6Address dst, Ipv6Address target, Address hardwareAddress);
+  virtual void SendNS (Ipv6Address src, Ipv6Address dst, Ipv6Address target, Address hardwareAddress);
 
   /**
    * \brief Send an error Destination Unreachable.
@@ -313,7 +320,7 @@
    * \param interface the interface
    * \param addr the IPv6 address
    */
-  static void FunctionDadTimeout (Ptr<Icmpv6L4Protocol> icmpv6, Ipv6Interface* interface, Ipv6Address addr);
+  void FunctionDadTimeout (Ipv6Interface* interface, Ipv6Address addr);
 
   /**
    * \brief Lookup in the ND cache for the IPv6 address
@@ -345,7 +352,7 @@
   /**
    * \brief Send a Router Solicitation.
    * \param src link-local source address
-   * \param dst destination address (usealy ff02::2 i.e all-routers)
+   * \param dst destination address (usually ff02::2 i.e all-routers)
    * \param hardwareAddress link-layer address (SHOULD be included if src is not ::)
    */
   void SendRS (Ipv6Address src, Ipv6Address dst,  Address hardwareAddress);
@@ -356,7 +363,7 @@
    * \param interface the IPv6 interface
    * \return a smart pointer of NdCache or 0 if problem
    */
-  Ptr<NdiscCache> CreateCache (Ptr<NetDevice> device, Ptr<Ipv6Interface> interface);
+  virtual Ptr<NdiscCache> CreateCache (Ptr<NetDevice> device, Ptr<Ipv6Interface> interface);
 
   /**
    * \brief Is the node must do DAD.
@@ -380,55 +387,8 @@
    */
   virtual void DoDispose ();
 
-private:
   typedef std::list<Ptr<NdiscCache> > CacheList; //!< container of NdiscCaches
 
-
-  /**
-   * \brief Neighbor Discovery node constants: max multicast solicitations.
-   */
-  uint8_t m_maxMulticastSolicit;
-
-  /**
-   * \brief Neighbor Discovery node constants: max unicast solicitations.
-   */
-  uint8_t m_maxUnicastSolicit;
-
-  /**
-   * \brief Neighbor Discovery node constants: reachable time.
-   */
-  Time m_reachableTime;
-
-  /**
-   * \brief Neighbor Discovery node constants: retransmission timer.
-   */
-  Time m_retransmissionTime;
-
-  /**
-   * \brief Neighbor Discovery node constants: delay for the first probe.
-   */
-  Time m_delayFirstProbe;
-
-  /**
-   * \brief The node.
-   */
-  Ptr<Node> m_node;
-
-  /**
-   * \brief A list of cache by device.
-   */
-  CacheList m_cacheList;
-
-  /**
-   * \brief Always do DAD ?
-   */
-  bool m_alwaysDad;
-
-  /**
-   * \brief Random jitter before sending solicitations
-   */
-  Ptr<RandomVariableStream> m_solicitationJitter;
-
   /**
    * \brief Notify an ICMPv6 reception to upper layers (if requested).
    * \param source the ICMP source
@@ -554,6 +514,52 @@
   virtual IpL4Protocol::DownTargetCallback GetDownTarget (void) const;
   virtual IpL4Protocol::DownTargetCallback6 GetDownTarget6 (void) const;
 
+  /**
+   * \brief Always do DAD ?
+   */
+  bool m_alwaysDad;
+
+  /**
+   * \brief A list of cache by device.
+   */
+  CacheList m_cacheList;
+
+private:
+  /**
+   * \brief Neighbor Discovery node constants: max multicast solicitations.
+   */
+  uint8_t m_maxMulticastSolicit;
+
+  /**
+   * \brief Neighbor Discovery node constants: max unicast solicitations.
+   */
+  uint8_t m_maxUnicastSolicit;
+
+  /**
+   * \brief Neighbor Discovery node constants: reachable time.
+   */
+  Time m_reachableTime;
+
+  /**
+   * \brief Neighbor Discovery node constants: retransmission timer.
+   */
+  Time m_retransmissionTime;
+
+  /**
+   * \brief Neighbor Discovery node constants: delay for the first probe.
+   */
+  Time m_delayFirstProbe;
+
+  /**
+   * \brief The node.
+   */
+  Ptr<Node> m_node;
+
+  /**
+   * \brief Random jitter before sending solicitations
+   */
+  Ptr<RandomVariableStream> m_solicitationJitter;
+
   IpL4Protocol::DownTargetCallback6 m_downTarget; //!< callback to Ipv6::Send
 
 };
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv4-address-generator.cc ns-3.31/src/internet/model/ipv4-address-generator.cc
--- ns-3.30.1/src/internet/model/ipv4-address-generator.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv4-address-generator.cc	2020-06-27 17:38:30.000000000 -0700
@@ -544,7 +544,7 @@
   const Ipv4Mask mask,
   const Ipv4Address addr)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (net << mask << addr);
 
   SimulationSingleton<Ipv4AddressGeneratorImpl>::Get ()
   ->Init (net, mask, addr);
@@ -553,7 +553,7 @@
 Ipv4Address
 Ipv4AddressGenerator::NextNetwork (const Ipv4Mask mask)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (mask);
 
   return SimulationSingleton<Ipv4AddressGeneratorImpl>::Get ()
          ->NextNetwork (mask);
@@ -562,7 +562,7 @@
 Ipv4Address
 Ipv4AddressGenerator::GetNetwork (const Ipv4Mask mask)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (mask);
 
   return SimulationSingleton<Ipv4AddressGeneratorImpl>::Get ()
          ->GetNetwork (mask);
@@ -573,7 +573,7 @@
   const Ipv4Address addr,
   const Ipv4Mask mask)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (addr << mask);
 
   SimulationSingleton<Ipv4AddressGeneratorImpl>::Get ()
   ->InitAddress (addr, mask);
@@ -582,7 +582,7 @@
 Ipv4Address
 Ipv4AddressGenerator::GetAddress (const Ipv4Mask mask)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (mask);
 
   return SimulationSingleton<Ipv4AddressGeneratorImpl>::Get ()
          ->GetAddress (mask);
@@ -591,7 +591,7 @@
 Ipv4Address
 Ipv4AddressGenerator::NextAddress (const Ipv4Mask mask)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (mask);
 
   return SimulationSingleton<Ipv4AddressGeneratorImpl>::Get ()
          ->NextAddress (mask);
@@ -609,7 +609,7 @@
 bool
 Ipv4AddressGenerator::AddAllocated (const Ipv4Address addr)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (addr);
 
   return SimulationSingleton<Ipv4AddressGeneratorImpl>::Get ()
          ->AddAllocated (addr);
@@ -618,7 +618,7 @@
 bool
 Ipv4AddressGenerator::IsAddressAllocated (const Ipv4Address addr)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (addr);
 
   return SimulationSingleton<Ipv4AddressGeneratorImpl>::Get ()
          ->IsAddressAllocated (addr);
@@ -627,7 +627,7 @@
 bool
 Ipv4AddressGenerator::IsNetworkAllocated (const Ipv4Address addr, const Ipv4Mask mask)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (addr << mask);
 
   return SimulationSingleton<Ipv4AddressGeneratorImpl>::Get ()
          ->IsNetworkAllocated (addr, mask);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv4-global-routing.cc ns-3.31/src/internet/model/ipv4-global-routing.cc
--- ns-3.30.1/src/internet/model/ipv4-global-routing.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv4-global-routing.cc	2020-06-27 17:38:30.000000000 -0700
@@ -152,7 +152,7 @@
        i++) 
     {
       NS_ASSERT ((*i)->IsHost ());
-      if ((*i)->GetDest ().IsEqual (dest)) 
+      if ((*i)->GetDest () == dest)
         {
           if (oif != 0)
             {
@@ -405,7 +405,7 @@
 
   *os << "Node: " << m_ipv4->GetObject<Node> ()->GetId ()
       << ", Time: " << Now().As (unit)
-      << ", Local time: " << GetObject<Node> ()->GetLocalTime ().As (unit)
+      << ", Local time: " << m_ipv4->GetObject<Node> ()->GetLocalTime ().As (unit)
       << ", Ipv4GlobalRouting table" << std::endl;
 
   if (GetNRoutes () > 0)
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv4-header.h ns-3.31/src/internet/model/ipv4-header.h
--- ns-3.30.1/src/internet/model/ipv4-header.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv4-header.h	2020-06-27 17:38:30.000000000 -0700
@@ -58,11 +58,14 @@
 public:
   /**
    * \enum DscpType
-   * \brief DiffServ Code Points
-   * Code Points defined in
-   * Assured Forwarding (AF) \RFC{2597}
-   * Expedited Forwarding (EF) \RFC{2598}
-   * Default and Class Selector (CS) \RFC{2474}
+   * \brief DiffServ codepoints
+   *
+   * The values correspond to the 6-bit DSCP codepoint within the 8-bit
+   * DS field defined in \RFC {2474}.  ECN bits are separately set with the
+   * SetEcn() method.  Codepoints are defined in
+   * Assured Forwarding (AF) \RFC{2597},
+   * Expedited Forwarding (EF) \RFC{2598}, and
+   * Default and Class Selector (CS) \RFC{2474}.
    */
   enum DscpType
     {
